/////////////////////////////////////////////////////////////////////////
//Jeder Core übernimmt die Berechnung eines waagrechten Bildabschnitts.
//Ist die Bildhöhe beispielsweise 800 Pixel und der Prozessor hat 16 Core
//dann bleibt für jeden Core ein Höhe von 50 Pixeln zu berechnen.
//Es kommt mitunter zu einigen wenigen unvorhersehbaren Pixelfehlern
////////////////////////////////////////////////////////////////////////
class MyThread extends Thread {
  
  
  double xmin,ymin;
  double wh;
  color farbe;
  PGraphics pg;
  int n;
  int Z; //ab hier wird registriert
  double KF; //Störungsfaktor
  int j;
  int tN;
  
  double[] fehlerAlt  = {0.8,0.6};
  double[] fehlerNeu = {0,0};
  double[][] J =  { {0,1} ,  
                    {0,1}  };
  boolean running = false;
  int zaehlen =0;
  double lambda;
  double laenge;
  double lambdaMin;
  double lambdaMax;
//////////////////////////////////////////////////////////  
// Threads anlegen und Parameter übergeben
//////////////////////////////////////////////////////////// 
  
  public MyThread(double px0, double py0, int pmaxiterations,  double pwh, int nummer, double K) {  
    wh = pwh;
    tN = nummer;  
    KF =K;
    xmin=px0; ymin=py0;   
    lambdaMin=10000;
    lambdaMax=0;
    Z = 100;
    n = pmaxiterations;   
    j=0;
    strokeWeight(1);
    //colorMode(RGB,256,256,256);
    colorMode(HSB,256,256,256);
    pg = createGraphics(width,height/anzahlThreads);  
  }
/////////////////////////////////////////////////////////  

  public int gibNummer(){ //hilfreich bei eventueller Fehlersuche  
    return tN;   
  }
//////////////////////////////////////////////////////////////
  
  public void run() { //println(fehler0);
    this.running = true;
    tN =this.gibNummer();
    pg.beginDraw();
      pg.loadPixels();
        double xmax = xmin + anzahlThreads*wh;      
        double ymax = ymin + wh;
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);     
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) {    
          double x = xmin;        
          for (int i = 0; i < pg.width; i++) {
          //if( tN==15){  
            lambda=0;
            fehlerAlt[0] = 0.8; fehlerAlt[1]  = 0.6;
            farbe = iteriere(x,y);
            //if(i==100 && j<3) farbe = iteriere(0.7914666533470154, 0.5752667784690857, i,j);            
            pg.pixels[i+j*pg.width] = farbe;  
         // }
            x += dx;
          }
          y += dy;
        }
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false; 
  }  
/////////////////////////////////////////////////////////////////////
color iteriere(double xH, double yH){ 
   color pixelFarbe;
   int i=1;
   fehlerAlt[0] = 0.8;
   fehlerAlt[1] = 0.6;
   laenge=0;
   J[0][0] = 1+K*Math.cos(2*Math.PI*xH);
   J[1][0] = J[0][0]-1; 
   //println(J[0][0], J[1][0]);
   //fehlerNeu =  MatrixAnwenden(fehlerAlt);  if(tN==10 )println(fehlerNeu);
   
   lambda =0;
   double xAlt, yAlt, xNeu, yNeu; //Parameter für Iteration Punkt 1
   
   xAlt = xH; 
   yAlt = yH; // println(xH,yH);
 //-------------------------------------------------------------
  while(i <=n){  
    
     fehlerNeu = MatrixAnwenden(fehlerAlt);//if(i==1 )println(fehlerNeu);
     laenge = Math.sqrt((fehlerNeu[0]*fehlerNeu[0])+(fehlerNeu[1]*fehlerNeu[1]));  //if(i<100) println(laenge);
    if(i >= Z && !(laenge == Double.POSITIVE_INFINITY)){
         if ( Math.log(laenge) > lambda ){ lambda = Math.log(laenge);}//   if( i<100) println(i,iI,jJ,lambda,tN); }                                        
     } 
     
     yNeu = yAlt + K*Math.sin(2*Math.PI*xAlt)/(2*Math.PI);
     xNeu = xAlt + yNeu;   
     
     J[0][0] = 1+K*Math.cos(2*Math.PI*xNeu);
     J[1][0] = J[0][0]-1;   
    
     xAlt = xNeu;
     yAlt = yNeu; 
     fehlerAlt = fehlerNeu;
   
     i++; 
  }
 //-----------------------------------------------------------------------
  i=0;  
  //lambda = lambda/(n-Z); println(lambda); 
  if(tN==0 &&lambda < lambdaMin) {lambdaMin = lambda; println("Min "+lambdaMin);}
  if(tN==0 &&lambda > lambdaMax) {lambdaMax = lambda; println("Max "+lambdaMax);}
  
 
  if(lambda < 10) pixelFarbe = color(160,255,30*(float)lambda);
  
  else pixelFarbe = color(0.2*(float)lambda,255,255);
 
  return    pixelFarbe;
}

 double[] MatrixAnwenden(double[] Fehler){
   double[] neuerFehlerVektor = {0,0};
   
   neuerFehlerVektor[0] = J[0][0]*Fehler[0]+J[0][1]*Fehler[1];
   neuerFehlerVektor[1] = J[1][0]*Fehler[0]+J[1][1]*Fehler[1];
 //  println(neuerFehlerVektor[0]);
   return neuerFehlerVektor;
 }
}
